## ga 5.3+dfsg

=== python/docs/pgas_11/Makefile ===
all: paper.pdf

paper.dvi: paper.tex bibliography.bib
	latex -shell-escape paper
	#bibtex paper
	latex -shell-escape paper
	latex -shell-escape paper

paper.pdf: paper.dvi
	dvipdf paper.dvi

clean:
	rm -f paper.aux paper.bbl paper.blg paper.dvi paper.log paper.pdf

=== python/docs/sc_11/Makefile ===
all: post174-daily.pdf post174-daily.ps

post174-daily.pdf: post174-daily.ps
	ps2pdf post174-daily.ps

# the following dvips invocation was recommended on 
# http://www.acm.org/sigs/publications/sigfaq#a14
post174-daily.ps: post174-daily.dvi
	dvips -P pdf -t letter -o post174-daily.ps post174-daily.dvi

post174-daily.dvi: post174-daily.tex post174-daily.bib laplace.eps python.eps
	latex  post174-daily
	bibtex post174-daily
	latex  post174-daily
	latex  post174-daily
	latex  post174-daily

laplace.eps: laplace.png
	convert laplace.png laplace.eps

laplace.png: laplace.gnuplot laplace.dat
	gnuplot laplace.gnuplot

python.eps: python.png
	convert python.png python.eps

python.png: python.gnuplot python.dat
	gnuplot python.gnuplot

clean:
	rm -f post174-daily.blg
	rm -f post174-daily.bbl
	rm -f post174-daily.dvi
	rm -f post174-daily.log
	rm -f post174-daily.aux
	rm -f post174-daily.ps
	rm -f post174-daily.pdf
	rm -f python.png
	rm -f python.eps
	rm -f laplace.png
	rm -f laplace.eps

=== debian/changelog ===
ga (5.3+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #603711).

 -- Michael Banck <mbanck@debian.org>  Fri, 05 Feb 2016 00:43:40 +0100

=== debian/control ===
Source: ga
Section: science
Priority: extra
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: autotools-dev,
               debhelper (>= 9.0~),
               gfortran,
               libblas-dev,
               liblapack-dev,
               libscalapack-mpi-dev,
               mpi-default-dev,
               openssh-client
Standards-Version: 3.9.6
Homepage: http://www.emsl.pnl.gov/docs/global/
Vcs-Browser: http://svn.debian.org/wsvn/debichem/unstable/ga/
Vcs-Svn: svn://svn.debian.org/svn/debichem/unstable/ga/

Package: libga-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Distributed Shared-Memory Programming Environment (development)
 Global Arrays is a portable Non-Uniform Memory Access (NUMA) shared-memory
 programming environment for distributed and shared memory computers. It
 augments the message-passing model by providing a shared-memory like access to
 distributed dense arrays.
 .
 ARMCI provides one-sided remote memory operations used by GA.
 .
 ComEx (Communication Runtime for Extreme Scale) provides vector and strided
 interfaces to optimize performance of remote memory copy operations for
 non-contiguous data.  
 .
 DRA (Disk Resident Arrays) is a parallel I/O library that maintains dense 2-dim
 arrays on disk.
 .
 SF (Shared Files) is a parallel I/O library that allows noncollective I/O to a
 parallel file.
 .
 EAF (Exclusive Access Files) is parallel I/O library that supports I/O to
 private files.
 .
 TCGMSG is a simple, efficient, but becoming obsolete message-passing library.
 .
 TCGMSG-MPI is a TCGMSG interface implementation on top of MPI and ARMCI.
 .
 MA is a dynamic memory allocator/manager for Fortran and C programs.
 .
 GA++ is a C++ binding for global arrays.
 .
 This package contains the static libraries and header files.

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS=-g -O2

%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- 				\
		--enable-cxx 				\
		--enable-shared				\
		--with-tcgmsg				\
		--with-scalapack=-lscalapack-openmpi	\
		--with-blas=-lblas 			\
		--with-lapack=-llapack			\
		--with-mpi

override_dh_auto_install:
	dh_auto_install --destdir=$(CURDIR)/debian/tmp
	rm -f $(CURDIR)/debian/tmp/usr/include/error.h
	rm -f $(CURDIR)/debian/tmp/usr/include/memcpy.h
	rm -f $(CURDIR)/debian/tmp/usr/include/scope.h
	rm -f $(CURDIR)/debian/tmp/usr/include/string-util.h
	rm -f $(CURDIR)/debian/tmp/usr/include/table.h
	
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	-dh_auto_test -- -j1 -k || cat armci/test-suite.log test-suite.log
endif

## ga 5.4~beta~r10636+dfsg

=== debian/changelog ===
ga (5.4~beta~r10636+dfsg-5) unstable; urgency=medium

  * Team upload
  * debian/control (Build-Depends): Drop versioned dependency
    on libarmci-mpi-dev binNMU
  * debian/clean: Add bltz.gmv to fix FTBFSx2
  * debian/rules (override_dh_auto_configure): Link with -lblacs-openmpi
    to avoid undefined reference to symbol 'blacs_gridexit_' (Closes: #857177)
  * debian/rules (override_dh_auto_test): Set ARMCI_USE_WIN_ALLOCATE=1
    to fix test failures (Closes: #846273)
  * debian/control: Use secure URI for Vcs-Browser and
    canonical URI for Vcs-Svn

 -- Graham Inggs <ginggs@debian.org>  Mon, 13 Mar 2017 15:45:36 +0200

ga (5.4~beta~r10636+dfsg-4) unstable; urgency=medium

  * debian/control (Build-Depends): Added libarmci-mpi-dev.
  * debian/rules (override_dh_auto_configure): Build against external libarmci
    from armci-mpi (Closes: 816699).
  * debian/rules (override_dh_auto_configure): Remove --enable-shared and
    --with-sockets configure options.

 -- Michael Banck <mbanck@debian.org>  Sun, 05 Mar 2017 13:16:28 +0100

ga (5.4~beta~r10636+dfsg-3) unstable; urgency=medium

  * debian/control: Renamed package libga-dev to libglobalarrays-dev 
    (Closes: 843141).
  * debian/control: Break and Replace previous libga-dev revisions.
  * debian/libga-dev.install: Renamed to ...
  * debian/libglobalarrays-dev.install: ... this.
  * debian/copyright: Add copyright and license information for FreeSerif.ttf.

 -- Michael Banck <mbanck@debian.org>  Wed, 23 Nov 2016 14:14:27 +0100

ga (5.4~beta~r10636+dfsg-2) unstable; urgency=medium

  * debian/patches/fix_comex_testsuite.patch: New patch, forces MPI to exact
    two processes for those comex tests which require them.
  * debian/patches/fix_armci_testsuite.patch: New patch, fixes linking failures
    of armci testsuite.
  * debian/rules (override_dh_auto_configure): Added --with-sockets option to
    match the 5.3 behaviour for now.

 -- Michael Banck <mbanck@debian.org>  Mon, 22 Feb 2016 14:05:27 +0100

ga (5.4~beta~r10636+dfsg-1) unstable; urgency=medium

  * New upstream development snapshot.
  * debian/patches/fix_ga_target.patch: Refreshed.

 -- Michael Banck <mbanck@debian.org>  Sun, 21 Feb 2016 18:56:13 +0100

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
 Build-Depends: autotools-dev,
                debhelper (>= 9.0~),
                gfortran,
+               libarmci-mpi-dev,
                libblas-dev,
                liblapack-dev,
                libscalapack-mpi-dev,
@@ -13,13 +14,15 @@
                openssh-client
 Standards-Version: 3.9.6
 Homepage: http://www.emsl.pnl.gov/docs/global/
-Vcs-Browser: http://svn.debian.org/wsvn/debichem/unstable/ga/
-Vcs-Svn: svn://svn.debian.org/svn/debichem/unstable/ga/
+Vcs-Browser: https://anonscm.debian.org/viewvc/debichem/unstable/ga/
+Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/ga/
 
-Package: libga-dev
+Package: libglobalarrays-dev
 Architecture: any
 Section: libdevel
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Replaces: libga-dev (<< 5.4~beta~r10636+dfsg-3)
+Breaks: libga-dev (<< 5.4~beta~r10636+dfsg-3)
 Description: Distributed Shared-Memory Programming Environment (development)
  Global Arrays is a portable Non-Uniform Memory Access (NUMA) shared-memory
  programming environment for distributed and shared memory computers. It

=== debian/rules ===
--- 
+++ 
@@ -8,12 +8,12 @@
 override_dh_auto_configure:
 	dh_auto_configure -- 				\
 		--enable-cxx 				\
-		--enable-shared				\
 		--with-tcgmsg				\
-		--with-scalapack=-lscalapack-openmpi	\
+		--with-scalapack="-lscalapack-openmpi -lblacs-openmpi" \
 		--with-blas=-lblas 			\
 		--with-lapack=-llapack			\
-		--with-mpi
+		--with-mpi				\
+		--with-armci=/usr
 
 override_dh_auto_install:
 	dh_auto_install --destdir=$(CURDIR)/debian/tmp
@@ -25,5 +25,5 @@
 	
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
-	-dh_auto_test -- -j1 -k || cat armci/test-suite.log test-suite.log
+	-dh_auto_test -- -j1 -k ARMCI_USE_WIN_ALLOCATE=1 || cat test-suite.log
 endif

## ga 5.7

=== comex/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: implements a primative CMake build that can be used to build
#              GA on Windows-based systems. Only MPI-based runtimes are
#              supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

option (COMEX_NETWORK_MPI_TS "use MPI 2-sided protocol for communication" OFF)
option (COMEX_NETWORK_MPI_PR "use MPI progress ranks protocol for communication" OFF)
option (COMEX_NETWORK_MPI3 "use MPI RMA protocols for communication" OFF)
option (COMEX_NETWORK_MPI_MT "use MPI multi-threading protocol for communication" OFF)
option (COMEX_NETWORK_MPI_PT "use MPI progress threads protocol for communication" OFF)
include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR} src-common)
if (MPI_TS)
  set(COMEX_DEVICE
    src-mpi/comex.c
    src-mpi/groups.c
  )
  set (COMEX_NETWORK_MPI_TS ON)
  include_directories(AFTER src-mpi)
elseif (MPI_PR)
  set(COMEX_DEVICE
    src-mpi-pr/comex.c
    src-mpi-pr/groups.c
    src-mpi-pr/reg_cache.c
  )
  set (COMEX_NETWORK_MPI_PR ON)
  include_directories(AFTER src-mpi-pr)
elseif (MPI3)
  set(COMEX_DEVICE
    src-mpi3/comex.c
    src-mpi3/groups.c
    src-mpi3/reg_win.c
  )
  set (COMEX_NETWORK_MPI3 ON)
  include_directories(AFTER src-mpi3)
elseif (MPI_MT)
  set(COMEX_DEVICE
    src-mpi-mt/comex.c
    src-mpi-mt/groups.c
  )
  set (COMEX_NETWORK_MPI_MT ON)
  include_directories(AFTER src-mpi-mt)
elseif (MPI_PT)
  set(COMEX_DEVICE
    src-mpi-pt/comex.c
    src-mpi-pt/groups.c
    src-mpi-pt/reg_cache.c
  )
  set (COMEX_NETWORK_MPI_PT ON)
  include_directories(AFTER src-mpi-pt)
endif()

find_package(MPI)

add_definitions (-DHAVE_CONFIG_H=1)

# -------------------------------------------------------------
# Check for variable sizes, include files and functions
# -------------------------------------------------------------

# check size of different variables
include(CheckTypeSize)
check_type_size("int" CM_SIZEOF_INT)
check_type_size("double" CM_SIZEOF_DOUBLE)
check_type_size("float" CM_SIZEOF_FLOAT)
check_type_size("long" CM_SIZEOF_LONG)
check_type_size("long double" CM_SIZEOF_LONG_DOUBLE)
check_type_size("long long" CM_SIZEOF_LONG_LONG)
check_type_size("short" CM_SIZEOF_SHORT)

# check for standard C/C++ include files
include(CheckIncludeFiles)
check_include_files("assert.h" HAVE_ASSERT_H)
check_include_files("limits.h" HAVE_LIMITS_H)
check_include_files("linux/limits.h" HAVE_LINUX_LIMITS_H)
check_include_files("malloc.h" HAVE_MALLOC_H)
check_include_files("math.h" HAVE_MATH_H)
check_include_files("stddef.h" HAVE_STDDEF_H)
check_include_files("stdint.h" HAVE_STDINT_H)
check_include_files("stdio.h" HAVE_STDIO_H)
check_include_files("stdlib.h" HAVE_STDLIB_H)
check_include_files("strings.h" HAVE_STRINGS_H)
check_include_files("string.h" HAVE_STRING_H)
check_include_files("sys/types.h" HAVE_SYS_TYPES_H)
check_include_files("unistd.h" HAVE_UNISTD_H)
check_include_files("windows.h" HAVE_WINDOWS_H)

# check for certain functions
include(CheckFunctionExists)
check_function_exists("bzero" HAVE_BZERO)

# -------------------------------------------------------------
# figure out what BLAS library looks like
# -------------------------------------------------------------
if (NOT DEFINED ENABLE_BLAS)
option (ENABLE_BLAS "Include external BLAS" ON)
endif()
INCLUDE( CheckCSourceCompiles )
if (ENABLE_BLAS)
set (CMAKE_REQUIRED_LIBRARIES blas)
CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = caxpy (n,c1,ca,1,cb,1);
char daxpy_result = daxpy (n,d1,da,1,db,1);
char saxpy_result = saxpy (n,s1,sa,1,sb,1);
char zaxpy_result = zaxpy (n,z1,za,1,zb,1);
char ccopy_result = ccopy (n,c1,ca,1,cb,1);
char dcopy_result = dcopy (n,d1,da,1,db,1);
char scopy_result = scopy (n,s1,sa,1,sb,1);
char zcopy_result = zcopy (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_1_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = caxpy_ (n,c1,ca,1,cb,1);
char daxpy_result = daxpy_ (n,d1,da,1,db,1);
char saxpy_result = saxpy_ (n,s1,sa,1,sb,1);
char zaxpy_result = zaxpy_ (n,z1,za,1,zb,1);
char ccopy_result = ccopy_ (n,c1,ca,1,cb,1);
char dcopy_result = dcopy_ (n,d1,da,1,db,1);
char scopy_result = scopy_ (n,s1,sa,1,sb,1);
char zcopy_result = zcopy_ (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_2_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = caxpy__ (n,c1,ca,1,cb,1);
char daxpy_result = daxpy__ (n,d1,da,1,db,1);
char saxpy_result = saxpy__ (n,s1,sa,1,sb,1);
char zaxpy_result = zaxpy__ (n,z1,za,1,zb,1);
char ccopy_result = ccopy__ (n,c1,ca,1,cb,1);
char dcopy_result = dcopy__ (n,d1,da,1,db,1);
char scopy_result = scopy__ (n,s1,sa,1,sb,1);
char zcopy_result = zcopy__ (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_3_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = CAXPY (n,c1,ca,1,cb,1);
char daxpy_result = DAXPY (n,d1,da,1,db,1);
char saxpy_result = SAXPY (n,s1,sa,1,sb,1);
char zaxpy_result = ZAXPY (n,z1,za,1,zb,1);
char ccopy_result = CCOPY (n,c1,ca,1,cb,1);
char dcopy_result = DCOPY (n,d1,da,1,db,1);
char scopy_result = SCOPY (n,s1,sa,1,sb,1);
char zcopy_result = ZCOPY (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_4_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = CAXPY_ (n,c1,ca,1,cb,1);
char daxpy_result = DAXPY_ (n,d1,da,1,db,1);
char saxpy_result = SAXPY_ (n,s1,sa,1,sb,1);
char zaxpy_result = ZAXPY_ (n,z1,za,1,zb,1);
char ccopy_result = CCOPY_ (n,c1,ca,1,cb,1);
char dcopy_result = DCOPY_ (n,d1,da,1,db,1);
char scopy_result = SCOPY_ (n,s1,sa,1,sb,1);
char zcopy_result = ZCOPY_ (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_5_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = CAXPY__ (n,c1,ca,1,cb,1);
char daxpy_result = DAXPY__ (n,d1,da,1,db,1);
char saxpy_result = SAXPY__ (n,s1,sa,1,sb,1);
char zaxpy_result = ZAXPY__ (n,z1,za,1,zb,1);
char ccopy_result = CCOPY__ (n,c1,ca,1,cb,1);
char dcopy_result = DCOPY__ (n,d1,da,1,db,1);
char scopy_result = SCOPY__ (n,s1,sa,1,sb,1);
char zcopy_result = ZCOPY__ (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_6_SIGNATURE )
endif()

# set blas symbols
if (BLAS_1_SIGNATURE)
  set(CM_BLAS_CAXPY caxpy)
  set(CM_BLAS_DAXPY daxpy)
  set(CM_BLAS_SAXPY saxpy)
  set(CM_BLAS_ZAXPY zaxpy)
  set(CM_BLAS_CCOPY ccopy)
  set(CM_BLAS_DCOPY dcopy)
  set(CM_BLAS_SCOPY scopy)
  set(CM_BLAS_ZCOPY zcopy)
elseif (BLAS_2_SIGNATURE)
  set(CM_BLAS_CAXPY caxpy_)
  set(CM_BLAS_DAXPY daxpy_)
  set(CM_BLAS_SAXPY saxpy_)
  set(CM_BLAS_ZAXPY zaxpy_)
  set(CM_BLAS_CCOPY ccopy_)
  set(CM_BLAS_DCOPY dcopy_)
  set(CM_BLAS_SCOPY scopy_)
  set(CM_BLAS_ZCOPY zcopy_)
elseif (BLAS_3_SIGNATURE)
  set(CM_BLAS_CAXPY caxpy__)
  set(CM_BLAS_DAXPY daxpy__)
  set(CM_BLAS_SAXPY saxpy__)
  set(CM_BLAS_ZAXPY zaxpy__)
  set(CM_BLAS_CCOPY ccopy__)
  set(CM_BLAS_DCOPY dcopy__)
  set(CM_BLAS_SCOPY scopy__)
  set(CM_BLAS_ZCOPY zcopy__)
elseif (BLAS_4_SIGNATURE)
  set(CM_BLAS_CAXPY CAXPY)
  set(CM_BLAS_DAXPY DAXPY)
  set(CM_BLAS_SAXPY SAXPY)
  set(CM_BLAS_ZAXPY ZAXPY)
  set(CM_BLAS_CCOPY CCOPY)
  set(CM_BLAS_DCOPY DCOPY)
  set(CM_BLAS_SCOPY SCOPY)
  set(CM_BLAS_ZCOPY ZCOPY)
elseif (BLAS_5_SIGNATURE)
  set(CM_BLAS_CAXPY CAXPY_)
  set(CM_BLAS_DAXPY DAXPY_)
  set(CM_BLAS_SAXPY SAXPY_)
  set(CM_BLAS_ZAXPY ZAXPY_)
  set(CM_BLAS_CCOPY CCOPY_)
  set(CM_BLAS_DCOPY DCOPY_)
  set(CM_BLAS_SCOPY SCOPY_)
  set(CM_BLAS_ZCOPY ZCOPY_)
elseif (BLAS_6_SIGNATURE)
  set(CM_BLAS_CAXPY CAXPY__)
  set(CM_BLAS_DAXPY DAXPY__)
  set(CM_BLAS_SAXPY SAXPY__)
  set(CM_BLAS_ZAXPY ZAXPY__)
  set(CM_BLAS_CCOPY CCOPY__)
  set(CM_BLAS_DCOPY DCOPY__)
  set(CM_BLAS_SCOPY SCOPY__)
  set(CM_BLAS_ZCOPY ZCOPY__)
else()
  set(CM_BLAS_CAXPY caxpy_)
  set(CM_BLAS_DAXPY daxpy_)
  set(CM_BLAS_SAXPY saxpy_)
  set(CM_BLAS_ZAXPY zaxpy_)
  set(CM_BLAS_CCOPY ccopy_)
  set(CM_BLAS_DCOPY dcopy_)
  set(CM_BLAS_SCOPY scopy_)
  set(CM_BLAS_ZCOPY zcopy_)
endif()

# check for weak alias pragma

CHECK_C_SOURCE_COMPILES(
"
extern void weakf(int c);
#pragma weak weakf = __weakf
void __weakf(int c) {}
int main(int argc, char **argv) {
  weakf(0);
  return(0);
}
"
   HAVE_SYS_WEAK_ALIAS_PRAGMA )

# Check for  FUNCTION_NAME

CHECK_C_SOURCE_COMPILES(
"
#include <stdio.h>
int sub(int i) {
  printf(\"%s\", __func__);
}
int main(int argc, char *argv[])
{
  sub(0);
  return 0;
}
"
    FUNCTION_1_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
#include <stdio.h>
int sub(int i) {
  printf(\"%s\", __FUNCTION__);
}
int main(int argc, char *argv[])
{
  sub(0);
  return 0;
}
"
    FUNCTION_2_SIGNATURE )
if (FUNCTION_1_SIGNATURE)
  set(CM_FUNCTION_NAME __func__)
elseif(FUNCTION_2_SIGNATURE)
  set(CM_FUNCTION_NAME __FUNCTION__)
else()
  set(CM_FUNCTION_NAME __func__)
endif()

# check for availability of some functions
include(CheckFunctionExists)
CHECK_FUNCTION_EXISTS(sched_setaffinity
     HAVE_SCHED_SETAFFINITY)
CHECK_FUNCTION_EXISTS(pthread_setaffinity_np
     HAVE_PTHREAD_SETAFFINITY_NP)



# generate config.h header file
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/config.h.in
                ${CMAKE_CURRENT_SOURCE_DIR}/config.h )

# -------------------------------------------------------------
# ARMCI and COMEX header installation
# -------------------------------------------------------------

set(ARMCI_HEADERS
  src-armci/armci.h
  src-armci/message.h
  src-armci/parmci.h
)

set(COMEX_DEVICE_HEADERS
  src-common/comex.h
)

install (FILES
  ${ARMCI_HEADERS}
  ${COMEX_DEVICE_HEADERS}

=== ma/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: implements a primative CMake build that can be used to build
#              GA on Windows-based systems. Only MPI-based runtimes are
#              supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR}
                    ${PROJECT_SOURCE_DIR}/gaf2c
)

if (NOT MSVC)
set(ctargetlibs ${MPI_C_LIBRARIES} m)
else()
set(ctargetlibs ${MPI_C_LIBRARIES})
endif()

# -------------------------------------------------------------
# MA header installation
# -------------------------------------------------------------

if (ENABLE_FORTRAN)
  set(FORTRAN_HEADERS maf2c.fh mafdecls.fh)
endif()

set(MA_HEADERS
  ma.h
#  error.h
  macdecls.h
  macommon.h
  matypes.h
#  memcpy.h
  scope.h
  string-util.h
  table.h
  ${FORTRAN_HEADERS}
)

install (FILES
  ${MA_HEADERS}
  DESTINATION include
)

# -------------------------------------------------------------
# MA library installation
# -------------------------------------------------------------

if (ENABLE_FORTRAN)
  set(FORTRAN_FILES f2c.c maf.F)
endif()

add_library(ma OBJECT
  ma.c
  error.c
  string-util.c
  table.c
  ${FORTRAN_FILES}
)

if (ENABLE_FORTRAN)
  ADD_DEPENDENCIES(ga_src GenerateConfigFH)
endif()

# -------------------------------------------------------------
# Build MA tests
# -------------------------------------------------------------

add_executable(testf.x testf.F)
add_executable(test-coalesce.x test-coalesce.c)
add_executable(test-inquire.x test-inquire.c)
#add_executable(testc.x testc.c)
target_link_libraries(testf.x ga ${ctargetlibs})
target_link_libraries(test-coalesce.x ga ${ctargetlibs})
target_link_libraries(test-inquire.x ga ${ctargetlibs})
#target_link_libraries(testc.x ga ${ctargetlibs})

=== pario/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: implements a primative CMake build that can be used to build
#              GA on Windows-based systems. Only MPI-based runtimes are
#              supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR}
                           ${CMAKE_CURRENT_SOURCE_DIR}/dra
                           ${CMAKE_CURRENT_SOURCE_DIR}/eaf
                           ${CMAKE_CURRENT_SOURCE_DIR}/elio
                           ${CMAKE_CURRENT_SOURCE_DIR}/sf
                           ${PROJECT_SOURCE_DIR}/gaf2c
                           ${PROJECT_SOURCE_DIR}/ma
                           ${PROJECT_SOURCE_DIR}/global/src)

# -------------------------------------------------------------
# PARIO header installation
# -------------------------------------------------------------

if (ENABLE_FORTRAN)
  set(DRA_FORTRAN_HEADERS
      dra/dra.fh
      dra/draf2c.h)
  set(DRA_FORTRAN_FILES
      dra/fortran.c)
  set(EAF_FORTRAN_HEADERS
      eaf/eaf.fh)
  set(EAF_FORTRAN_FILES
      eaf/eaf_f2c.c)
  set(SF_FORTRAN_HEADERS
      sf/sf.fh
      sf/sff2c.h)
  set(SF_FORTRAN_FILES
      sf/sf_fortran.c)
endif()

set(DRA_HEADERS
  dra/dra.h
#  dra/buffers.h
#  dra/drap.h
  ${DRA_FORTRAN_HEADERS}
)

set(EAF_HEADERS
  eaf/eaf.h
#  eaf/eafP.h
  ${EAF_FORTRAN_HEADERS}
)

set(ELIO_HEADERS
   elio/elio.h
   elio/chemio.h
#   elio/eliop.h
#   elio/pablo.h
)

set(SF_HEADERS
    sf/sf.h
    sf/coms.h
    ${SF_FORTRAN_HEADERS}
)

install (FILES
  ${DRA_HEADERS}
  ${EAF_HEADERS}
  ${ELIO_HEADERS}
  ${SF_HEADERS}
  DESTINATION include
)

# -------------------------------------------------------------
#  PARIO executable files
# -------------------------------------------------------------

set(DRA_FILES
    dra/disk.arrays.c
    dra/buffers.c
    dra/capi.c
    dra/disk.param.c
    dra/env.c
    dra/global.unsup.c
    dra/patch.util.c
    dra/util.c
    ${DRA_FORTRAN_FILES}
)

set(EAF_FILES
    eaf/eaf.c
    ${EAF_FORTRAN_FILES}
)

set(ELIO_FILES
    elio/elio.c
    elio/stat.c
)

set(SF_FILES
     sf/shared.files.c
     sf/sf_capi.c
     ${SF_FORTRAN_FILES}
)

# -------------------------------------------------------------
# PARIO library installation
# -------------------------------------------------------------

add_library(dra OBJECT ${DRA_FILES})
add_library(eaf OBJECT ${EAF_FILES})
add_library(elio OBJECT ${ELIO_FILES})
add_library(sf OBJECT ${SF_FILES})

=== LinAlg/lapack+blas/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: implements a primative CMake build that can be used to build
#              GA on Windows-based systems. Only MPI-based runtimes are
#              supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR})

# -------------------------------------------------------------
# LinAlg header installation
# -------------------------------------------------------------

set(LINALG_HEADERS
  xgemm.h
)

# -------------------------------------------------------------
# LINALG library installation
# -------------------------------------------------------------

if (ENABLE_FORTRAN)
    set(FORTRAN_FILES
        gal_cgemm.f
        gal_daxpy.f
        gal_dcabs1.f
        gal_dcopy.f
        gal_ddot.f
        gal_dgemm.f
        gal_dgemv.f
        gal_dger.f
        gal_dgetf2.f
        gal_dgetrf.f
        gal_dgetrs.f
        gal_disnan.f
        gal_dlacpy.f
        gal_dlae2.f
        gal_dlaev2.f
        gal_dlaisnan.f
        gal_dlamch.f
        gal_dlanst.f
        gal_dlansy.f
        gal_dlapy2.f
        gal_dlarfb.f
        gal_dlarf.f
        gal_dlarfg.f
        gal_dlarft.f
        gal_dlartg.f
        gal_dlascl.f
        gal_dlaset.f
        gal_dlasr.f
        gal_dlasrt.f
        gal_dlassq.f
        gal_dlaswp.f
        gal_dlatrd.f
        gal_dnrm2.f
        gal_dorg2l.f
        gal_dorg2r.f
        gal_dorgql.f
        gal_dorgqr.f
        gal_dorgtr.f
        gal_dpotf2.f
        gal_dpotrf.f
        gal_dscal.f
        gal_dsteqr.f
        gal_dsterf.f
        gal_dswap.f
        gal_dsyev.f
        gal_dsygs2.f
        gal_dsygst.f
        gal_dsygv.f
        gal_dsymm.f
        gal_dsymv.f
        gal_dsyr2.f
        gal_dsyr2k.f
        gal_dsyrk.f
        gal_dsytd2.f
        gal_dsytrd.f
        gal_dtrmm.f
        gal_dtrmv.f
        gal_dtrsm.f
        gal_dtrsv.f
        gal_idamax.f
        gal_ieeeck.f
        gal_iladlc.f
        gal_iladlr.f
        gal_ilaenv.f
        gal_iparmq.f
        gal_lsame.f
        gal_sgemm.f
        gal_xerbla.f
        gal_zaxpy.f
        gal_zgemm.f
      )
endif()

add_library(linalg OBJECT
  xgemm.c
  ${FORTRAN_FILES}
)

=== ga++/src/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: implements a primative CMake build that can be used to build
#              GA on Windows-based systems. Only MPI-based runtimes are
#              supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR}
                    ${PROJECT_SOURCE_DIR}/global/src
                    ${PROJECT_SOURCE_DIR}/global/testing
                    ${PROJECT_SOURCE_DIR}/ma
                    ${PROJECT_SOURCE_DIR}/gaf2c)

# -------------------------------------------------------------
# GA++ header installation
# -------------------------------------------------------------

set(GAXX_HEADERS
  ga++.h
  GAServices.h
  GlobalArray.h
  init_term.h
  PGroup.h
  services.h
)

install (FILES
  ${GAXX_HEADERS}
  DESTINATION include
)

# -------------------------------------------------------------
# GA++ library installation
# -------------------------------------------------------------

add_library(ga++
  GAServices.cc
  GlobalArray.cc
  init_term.cc
  overload.cc
  PGroup.cc
  services.cc
)

target_link_libraries(ga++)

install (TARGETS
  ga++
  DESTINATION lib
)

=== debian/changelog ===
ga (5.7-6) unstable; urgency=medium

  * debian/rules (override_dh_auto_configure): Remove --enable-peigs from
    configure options.
  * debian/salsa-ci.yml: New file.
  * debian/rules (override_dh_auto_test): Set MPIEXEC variable.
  * debian/patches/testsuite_log_compiler.patch: New patch, fixes test suite
    harness script.

 -- Michael Banck <mbanck@debian.org>  Wed, 08 Jan 2020 15:08:10 +0100

ga (5.7-5) unstable; urgency=medium

  * Team upload.
  * Patch fix_MPI_errhandler_f1ea520.patch applies upstream commit
    f1ea520 to update MPI errhandler for MPI-3 API.
  * Standards-Version: 4.4.1
  * debhelper compatibility level 12: debhelper-compat (= 12)

 -- Drew Parsons <dparsons@debian.org>  Sat, 21 Dec 2019 23:45:48 +1100

ga (5.7-4) unstable; urgency=medium

  * debian/patches/ga_diag_seq.patch: New patch, fixes Fortran integer casting
    in ga_diag, taken Edoardo Aprà's Fedora package patches.
  * debian/rules (override_dh_auto_configure): Added --enable-peigs to
    configure options.

 -- Michael Banck <mbanck@debian.org>  Sun, 20 Jan 2019 18:58:29 +0100

ga (5.7-3) unstable; urgency=medium

  * debian/libglobalarrays-dev.install: Ship /usr/bin/ga-config.
  * debian/control (Multi-Arch): New field.

 -- Michael Banck <mbanck@debian.org>  Tue, 01 Jan 2019 23:27:03 +0100

ga (5.7-2) unstable; urgency=medium

  * Team upload.
  * incorporate NMU 5.4~beta~r10636+dfsg-5.1 into main repo
    (scalapack v2 fixes, in particular)

 -- Drew Parsons <dparsons@debian.org>  Sun, 30 Dec 2018 23:29:47 +0100

ga (5.7-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * add debian/watch, pointing at new upstream repo
    https://github.com/GlobalArrays/ga
  * update debian/copyright
    - remove Files-Excluded from debian/copyright:
      BGML and DCMF ports and dmapp.h.bak have been removed
    - disambiguate "License: other"
  * update debian/control
    - update upstream Homepage to http://hpc.pnl.gov/globalarrays/
    - Priority: optional not extra
    - remove autotools-dev (already required by default by dh 11)
  * specify dh build with autoreconf
  * update debian/docs (source now provides README.md)
  * Standards-Version: 4.3.0
  * debhelper compatibility level 11

 -- Drew Parsons <dparsons@debian.org>  Sun, 30 Dec 2018 21:43:04 +0100

ga (5.4~beta~r10636+dfsg-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Standards-Version: 4.1.0
  * debhelper compatibility level 10
  * Link to scalapack for default MPI
  * Update build for scalapack 2:
    - remove explicit -lblacs reference
      (BLACS is now included in scalapack2)
    - Build-Depends: libscalapack-mpi-dev (>= 2)

 -- Drew Parsons <dparsons@debian.org>  Mon, 11 Sep 2017 19:14:16 +0800

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,20 @@
 Source: ga
 Section: science
-Priority: extra
+Priority: optional
 Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
 Uploaders: Michael Banck <mbanck@debian.org>
-Build-Depends: autotools-dev,
-               debhelper (>= 9.0~),
+Build-Depends: debhelper-compat (= 12),
                gfortran,
                libarmci-mpi-dev,
                libblas-dev,
                liblapack-dev,
-               libscalapack-mpi-dev,
+               libscalapack-mpi-dev (>= 2),
                mpi-default-dev,
                openssh-client
-Standards-Version: 3.9.6
-Homepage: http://www.emsl.pnl.gov/docs/global/
-Vcs-Browser: https://anonscm.debian.org/viewvc/debichem/unstable/ga/
-Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/ga/
+Standards-Version: 4.4.1
+Homepage: http://hpc.pnl.gov/globalarrays/
+Vcs-Browser: https://salsa.debian.org/debichem-team/ga
+Vcs-Git: https://salsa.debian.org/debichem-team/ga.git
 
 Package: libglobalarrays-dev
 Architecture: any
@@ -23,6 +22,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: libga-dev (<< 5.4~beta~r10636+dfsg-3)
 Breaks: libga-dev (<< 5.4~beta~r10636+dfsg-3)
+Multi-Arch: no
 Description: Distributed Shared-Memory Programming Environment (development)
  Global Arrays is a portable Non-Uniform Memory Access (NUMA) shared-memory
  programming environment for distributed and shared memory computers. It

=== debian/rules ===
--- 
+++ 
@@ -2,14 +2,16 @@
 
 CFLAGS=-g -O2
 
+include /usr/share/mpi-default-dev/debian_defaults
+
 %:
-	dh $@ 
+	dh $@ --with autoreconf
 
 override_dh_auto_configure:
 	dh_auto_configure -- 				\
 		--enable-cxx 				\
 		--with-tcgmsg				\
-		--with-scalapack="-lscalapack-openmpi -lblacs-openmpi" \
+		--with-scalapack="-lscalapack-$(ARCH_DEFAULT_MPI_IMPL)" \
 		--with-blas=-lblas 			\
 		--with-lapack=-llapack			\
 		--with-mpi				\
@@ -25,5 +27,5 @@
 	
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
-	-dh_auto_test -- -j1 -k ARMCI_USE_WIN_ALLOCATE=1 || cat test-suite.log
+	-dh_auto_test -- -j1 -k ARMCI_USE_WIN_ALLOCATE=1 MPIEXEC="mpiexec -np 4"
 endif
